/*-
 * Copyright (C) @BABOLO  2000 Jul 30
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *
 * $FreeBSD:  $ 
 */

#define BUF_SZ 8192
u_char in_buf[BUF_SZ];
size_t bg_buf, net_buf;

void init_next()
{   bg_buf = net_buf = 0;
}

int get_next(int fin, struct WriteStruct *next)
{   void *to = next;
    size_t trans, to_do = sizeof(struct WriteStruct);
    while (to_do)
    {   if  (bg_buf >= net_buf)
        {   net_buf = read(fin, in_buf, BUF_SZ);
            bg_buf = 0;
            if  (net_buf == 0) return(0);
        }
        trans = net_buf - bg_buf;
        if  (trans > to_do) trans = to_do;
        bcopy(&in_buf[bg_buf], to, trans);
        bg_buf += trans;
        to += trans;
        to_do -=trans;
    }
    return(sizeof(struct WriteStruct) - to_do);
}
