#include <sys/types.h>
#include <sysexits.h>
#include <sys/uio.h>
#include <unistd.h>
#include <stdlib.h>
#include <limits.h>
#include <fcntl.h>
#include <stdio.h>
#include <err.h>
#include "traf_ex_record.h"

int flag_v;
u_char *myname;

char *eth_to_txt(u_char *txt, u_char *eth)
{   sprintf( txt
           , "%x:%x:%x:%x:%x:%x"
           , eth[5], eth[4], eth[3], eth[2], eth[1], eth[0]
           );
    return(txt);
};

char *ip_to_txt(u_char *txt, u_char *ip)
{   sprintf( txt
           , "%d.%d.%d.%d"
           , ip[0], ip[1], ip[2], ip[3]
           );
    return(txt);
};

void usage(int status)
{   fprintf( stderr
           , "traf-db @BABOLO V.M "VERS"  "DATE"\n"
             "   Usage:\n"
             "traf-db -[t|i] -f 'format' -r infile -n table_name -R router -I interface\n"
           );
    exit(status);
}

int main(int argc, char **argv)
{   u_char *format;
    u_char eth_txt[24];
    u_char ip_txt[24];
    u_char *t_name, *Host;
    u_char *Router, *Interface, *Time;
    int c, flag_i, flag_t;
    int fin;
    struct traf_ex_record in;

    myname = *argv;
    format = NULL;
    t_name = NULL;
    Router = NULL;
    Interface = NULL;
    Host = NULL;
    Time = "timenow()";
    flag_v = flag_t = flag_i = 0;
    fin = fileno(stdin);
    while ((c = getopt(argc, argv, "vitf:r:n:R:I:H:T:h")) > 0)
    {   switch (c)
        {case 'v': flag_v++;                                 break;
         case 'i': flag_i++;                                 break;
         case 't': flag_t++;                                 break;
         case 'f': format = optarg;                          break;
         case 'r': if  (!(fin = open(optarg, O_RDONLY)))     err(EX_NOINPUT, "Not opened: %s", optarg);
                                                             break;
         case 'n': t_name = optarg;                          break;
         case 'R': Router = optarg;                          break;
         case 'I': Interface = optarg;                       break;
         case 'H': Host = optarg;                            break;
         case 'T': Time = optarg;                            break;
         case 'h': usage(EX_OK);
         default: usage(EX_USAGE);
    }   }
    if  (flag_i && flag_t)
    {   fprintf(stderr, "%s: can't use -it flags together\n", myname);                exit(EX_DATAERR);
    }

    argc -= optind;
    argv += optind;

    if  (flag_i)
    {   if  (!t_name) t_name = "iaddr_temp_tick";
    ;   if  (!format)
              format
            = "INSERT INTO %s(mac,ip,time,outp,inp,router,iface)"
              " VALUES('%s','%s/32'"
                     ",%s"
                     ",%qu,%qu"
                     ",%s,%s"
                     ");\n";
    ;   while (sizeof(in) == read(fin, &in, sizeof(in)))
        {   printf( format, t_name
                  , eth_to_txt(eth_txt, in.MAC_addr)
                  , ip_to_txt(ip_txt, in.iad)
                  , Time
                  , in.i_record.sent, in.i_record.rcvd
                  , Router, Interface
                  );
    }   }
    if  (flag_t)
    {   if  (!t_name) t_name = "itraf_temp_tick";
    ;   if  (!format)
              format
            = (Host) ? "INSERT INTO %s(mac,ip,time,wclass,count,router,iface)"
                       " VALUES('%s','%s/32'"
                              ",%s"
                              ",%u,%qu"
                              ",%s,%s"
                              ");\n"
                     : "INSERT INTO %s(mac,time,wclass,count,router,iface)"
                       " VALUES('%s'"
                              ",%s"
                              ",%u,%qu"
                              ",%s,%s"
                              ");\n"
        ;
    ;   while (sizeof(in) == read(fin, &in, sizeof(in)))
        {   if  (Host)
                 printf( format, t_name
                       , eth_to_txt(eth_txt, in.MAC_addr)
                       , Host, Time
                       , in.t_record.category, in.t_record.bcount
                       , Router, Interface
                       );
            else printf( format, t_name
                       , eth_to_txt(eth_txt, in.MAC_addr)
                       , Time
                       , in.t_record.category, in.t_record.bcount
                       , Router, Interface
                       );
    }   }
    exit(EX_OK);
}
